//****************************************************************************
//	Axppi02w.pas
//
//	AXP-PI02
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//****************************************************************************

unit Axppi02w;

interface

uses
	Windows;

{ Error Code }

const
	PI02_SUCCESS								= 0; 	{ Successfully proccessed }
	PI02_ERR_SYSTEM							= 1; 	{ Call GetLastError() }
	PI02_ERR_NO_DEVICE					= 2; 	{ No card }
	PI02_ERR_IN_USE							= 3; 	{ Device is in use }
	PI02_ERR_INVALID_SOCKET			= 4; 	{ Invalid socket number }
	PI02_ERR_RESOURCE						= 5; 	{ Resource exhaustion }
	PI02_ERR_INVALID_PORT				= 6; 	{ Invalid port }
	PI02_ERR_INVALID_ARGUMENT		= 7; 	{ Invalid argument }

{ Miscellaneous }

const
	PI02_MAX_SOCKETS	= 16;						{ Maximum number of slots }
	PI02_SOCKET_AUTO 	= $ffff; 				{ default search }
	PI02_PORT_A				=	$0;						{ Port A }
	PI02_PORT_B				=	$1; 					{ Port B }
	PI02_PORT_C				=	$2;						{ Port C }
	PI02_PORT_CMD			=	$3;						{ Command port }

const
	PI02_ERR_WRAPDLL = DWord(-1); 		{ bp[֐G[ }

const
	PI02_DLL_NAME = 'Axppi02.dll';		{ DLL }

const
  PI02_WM_OFS_CARD_REMOVAL	= 0;
  PI02_WM_OFS_IN						= 1;

function Pi02wDllOpen: Boolean;			{ DLL [h }
function Pi02wDllClose: Boolean;		{ DLL A[h }


{ AXP-PI02 DLL,Drṽo[Wԍ擾 }
function Pi02wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;
{ CӂAXP-PI02̎gp錾 }
function Pi02wCreate(var pwLogSocket: Word; hWnd: THandle; uWMBase: UInt; var pvInitArg): Boolean;
{ CӂAXP-PI02̎gpJ }
function Pi02wClose(wLogSocket: Word): Boolean;

{ Resource infomation structure }
const
	PI02_MAX_MEM			=	 9;
	PI02_MAX_IO				= 20;
	PI02_MAX_IRQ			=	 7;
	PI02_MAX_DMA			=	 7;

type
	TPI02_RESOURCE = record
		dwNumMemWindows:															DWord;	{ س޳(gp) }
		dwMemBase:			array [1 .. PI02_MAX_MEM] of	DWord;	{ س޳ްڽ(gp) }
		dwMemLength:		array [1 .. PI02_MAX_MEM] of	DWord;	{ س޳(gp) }
		dwMemAttrib:		array [1 .. PI02_MAX_MEM] of	DWord;	{ س޳(gp) }
		dwNumIOPorts:																	DWord;	{ I/O߰Đ }
		dwIOPortBase:		array [1 .. PI02_MAX_IO] of		DWord;	{ I/O߰ްڽ }
		dwIOPortLength: array [1 .. PI02_MAX_IO] of		DWord;	{ I/O߰Ē }
		dwNumIRQs:																		DWord;	{ IRQ(gp) }
		dwIRQRegisters: array [1 .. PI02_MAX_IRQ] of	DWord;	{ IRQؽ(gp) }
		dwIRQAttrib:		array [1 .. PI02_MAX_IRQ] of	DWord;	{ IRQؽ(gp) }
		dwNumDMAs:																		DWord;	{ DMAِ(gp) }
		dwDMALst:				array [1 .. PI02_MAX_DMA] of	DWord;	{ DMAؽ(gp) }
		dwDMAAttrib:		array [1 .. PI02_MAX_DMA] of	DWord;	{ DMAّؽ(gp) }
		dwReserved1:		array [1 .. 3] of							DWord;	{ \(gp) }
	end;

PPI02_R = ^TPI02_RESOURCE;
{ \[X擾 }
function Pi02wGetResource(wLogSocket: Word; pres: PPI02_R): Boolean;
{ |[gf[^ }
function Pi02wInPort(wLogSocket: Word;dwPort: DWord; var pbValue: Byte): Boolean;
{ |[gփf[^o }
function Pi02wOutPort(wLogSocket: Word;dwPort: DWord; bValue: Byte): Boolean;
{ fBNV|[gɏo }
function Pi02wSetDirection(wLogSocket: Word;bDirectionBit: Byte): Boolean;
{ G[R[h̎擾 }
function Pi02wGetLastError(wLogSocket: Word): DWord;

implementation

type
	TPi02GetVersion = function(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean; stdcall;
	TPi02Create = function(var pwLogSocket: Word; hWnd: THandle; uWMBase: UInt; var pvInitArg): Boolean; stdcall;
	TPi02Close = function(wLogSocket:	Word): Boolean; stdcall;
	TPi02GetResource = function(wLogSocket: Word; pres: PPI02_R): Boolean; stdcall;
	TPi02InPort = function(wLogSocket: Word;dwPort: DWord; var pbValue: Byte ): Boolean; stdcall;
	TPi02OutPort = function(wLogSocket: Word; dwPort: DWord; bValue: Byte ): Boolean; stdcall;
	TPi02SetDirection = function(wLogSoket: Word; bDirectionBit: Byte ): Boolean; stdcall;
	TPi02GetLastError = function(wLogSocket: Word ): DWord; stdcall;

function Pi02wGetDllExportFunc: Boolean; forward;

{$J+}
const
	hDLL: THandle = 0;
{$J-}

{ DLL GNX|[g֐AhX̊i[ϐ }
var
	pPi02GetVersion: 	TPi02GetVersion;
	pPi02Create: 			TPi02Create;
	pPi02Close: 			TPi02Close;
	pPi02GetResource: TPi02GetResource;
	pPi02InPort:			TPi02InPort;
	pPi02OutPort:			TPi02OutPort;
	pPi02SetDirection:TPi02SetDirection;
	pPi02GetLastError:TPi02GetLastError;

//****************************************************************************
// 		Axppi02.dll[h
// 		
// ߂l  True
//				s False
//****************************************************************************
function Pi02wDllOpen: Boolean;
begin
	Result := False;

	if hDLL <> 0 then Exit;

	hDLL := LoadLibrary(PI02_DLL_NAME);
	if hDLL = 0 then Exit;

	if Pi02wGetDllExportFunc = False then
	begin
		Pi02wDllClose;	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Exit;
	end;

	Result := True;
end;

//****************************************************************************
// 		Axppi02.dllA[h
// 		
// ߂l  True
//				s False
//****************************************************************************
function Pi02wDllClose: Boolean;
begin
	Result := True;

	if hDLL = 0 then Exit;

	if FreeLibrary(hDLL) = True then hDLL := 0
	else Result := False;
end;

//****************************************************************************
// 		AXP-PI02 DLL,Vxd̃o[Wԍ擾
// 		pdwDllVer DLLo[Wԍi[
//				pdwDrvVer Drvo[Wԍi[
// ߂l  True
//				s False
//****************************************************************************
function Pi02wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pPi02GetVersion(pdwDllVer, pdwDrvVer);
end;

//****************************************************************************
// 		AXP-PI02̔Cӂ̃foCX̎gp錾
// 		pwLogSocket	 gpfoCXi[
// ߂l  True
//				s False
//****************************************************************************
function Pi02wCreate(var pwLogSocket: Word; hWnd: THandle; uWMBase: UInt; var pvInitArg): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pPi02Create(pwLogSocket, hWnd, uWMBase, pvInitArg);
end;

//****************************************************************************
// 		AXP-PI02̔Cӂ̃foCX̎gpJ
// 		wLogSocket gpfoCX
// ߂l  True
//				s False
//****************************************************************************
function Pi02wClose(wLogSocket: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pPi02Close(wLogSocket);
end;

//****************************************************************************
// 		wfoCX̃\[X擾
// 		wLogSocket ׂfoCX
//				pres		 \[Xi[\
// ߂l  True
//				s False
//****************************************************************************
function Pi02wGetResource(wLogSocket: Word; pres: PPI02_R): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pPi02GetResource(wLogSocket, pres);
end;

//****************************************************************************
// 		|[g``bɑ΂PoCg͂s܂
// 		wLogSocket ΏۃfoCX
//				dwPort     |[gԍ
//        pbValue    ̓f[^i[̈ւ̃|C^
// ߂l  True
//				s False
//****************************************************************************
function Pi02wInPort(wLogSocket: Word;dwPort: DWord; var pbValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pPi02InPort(wLogSocket, dwPort, pbValue);
end;

//****************************************************************************
// 		|[g``bA܂̓R}h|[gւPoCgo
// 		wLogSocket ΏۃfoCX
//				dwPort     |[gԍ
//        bValue     o̓f[^
// ߂l  True
//				s False
//****************************************************************************
function Pi02wOutPort(wLogSocket: Word;dwPort: DWord; bValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pPi02OutPort(wLogSocket, dwPort, bValue);
end;

//****************************************************************************
// 		fBNV|[gɏo
// 		wLogSocket    ΏۃfoCX
//        bDirectionBit o̓f[^
// ߂l  True
//				s False
//****************************************************************************
function Pi02wSetDirection(wLogSocket: Word;bDirectionBit: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pPi02SetDirection(wLogSocket, bDirectionBit);
end;

//****************************************************************************
// 		AXP-PI02̃G[R[h
// 		wLogSocket	G[foCX
// ߂l G[R[h
//****************************************************************************
function Pi02wGetLastError(wLogSocket: Word): DWord;
begin
	Result := PI02_ERR_WRAPDLL;

	if hDLL = 0 then Exit;

	Result := pPi02GetLastError(wLogSocket);
end;

//---------------------------------------------------------------------------
// 		DLLGNX|[g֐AhX̎擾
// 		
// ߂l  True
//				s False
//---------------------------------------------------------------------------
function Pi02wGetDllExportFunc: Boolean;
begin
	Result := False;

	// Pi02GetVersion ̃AhX擾
	pPi02GetVersion := GetProcAddress(hDLL, 'Pi02GetVersion');
	if @pPi02GetVersion = nil then Exit;

	// Pi02Create ̃AhX擾
	pPi02Create := GetProcAddress(hDLL, 'Pi02Create');
	if @pPi02Create = nil then Exit;

	// Pi02Close ̃AhX擾
	pPi02Close := GetProcAddress(hDLL, 'Pi02Close');
	if @pPi02Close = nil then Exit;

	// Pi02GetResource ̃AhX擾
	pPi02GetResource := GetProcAddress(hDLL, 'Pi02GetResource');
	if @pPi02GetResource = nil then Exit;

	// Pi02InPort ̃AhX擾
	pPi02InPort := GetProcAddress(hDLL, 'Pi02InPort');
	if @pPi02InPort = nil then Exit;

	// Pi02OutPort ̃AhX擾
	pPi02OutPort := GetProcAddress(hDLL, 'Pi02OutPort');
	if @pPi02InPort = nil then Exit;

	// Pi02SetDirection ̃AhX擾
	pPi02SetDirection := GetProcAddress(hDLL, 'Pi02SetDirection');
	if @pPi02SetDirection = nil then Exit;

	// Pi02GetLastError ̃AhX擾
	pPi02GetLastError := GetProcAddress(hDLL, 'Pi02GetLastError');
	if @pPi02GetLastError = nil then Exit;

	Result := True;	// SĂ DLL GNX|[g֐AhX擾
end;

end.

