/*============================================================================
//	Axppi02w.h
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//==========================================================================*/
#pragma once

#include <windows.h>

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Threading;
using namespace System::Runtime::InteropServices;

#ifdef MessageBox
#undef MessageBox
#endif

// NX̐錾
__gc public class Axppi02w;

__gc public class Axppi02w
{
private:
	static int mErrWradll = SUCCESS;	// bp[֐G[

public:
	static const int	MAX_SOCKETS				= 16;
	static const short	SOCKET_AUTO				= -1;

	static const int	PORT_A					= 0x0;	// |[g`
	static const int	PORT_B					= 0x1;	// |[ga
	static const int	PORT_C					= 0x2;	// |[gb
	static const int	PORT_CMD				= 0x3;	// R}h|[g

	// G[R[h
	static const int	SUCCESS					= 0;	// ُȂiIj
	static const int	ERR_SYSTEM				= 1;	// Windows  GetLastError() R[Ă
														// ɃhCo[hĂȂ\܂
	static const int	ERR_NO_DEVICE			= 2;	// gp\ȃfoCX܂
	static const int	ERR_IN_USE				= 3;	// w̃foCX͎gpł
	static const int	ERR_INVALID_SOCKET		= 4;	// Ș_\Pbgł
	static const int	ERR_RESOURCE			= 5;	// \[XG[
	static const int	ERR_INVALID_PORT		= 6;	// sȃ|[gv
	static const int	ERR_INVALID_ARGUMENT	= 7;	// sȈv܂
	static const int	ERR_WRAPDLL				= -1;	// bp[֐G[

	// AvP[Vɑ郁bZ[W
	static const int	WM_OFS_CARD_REMOVAL		= 0;	// J[hꂽ
	static const int	WM_OFS_IN				= 1;	// O͔iIvVj

	// \[X\
	static const int	MAX_MEM					= 9;
	static const int	MAX_IO					= 20;
	static const int	MAX_IRQ					= 7;
	static const int	MAX_DMA					= 7;
	static const int	MAX_RSV					= 3;

	[StructLayout(LayoutKind::Sequential)]
	__gc class Resource
	{
	public:
		Int32 dwNumMemWindows;
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axppi02w::MAX_MEM)]
		Int32 dwMemBase[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axppi02w::MAX_MEM)]
		Int32 dwMemLength[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axppi02w::MAX_MEM)]
		Int32 dwMemAttrib[];
		Int32 dwNumIOPorts;
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axppi02w::MAX_IO)]
		Int32 dwIOPortBase[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axppi02w::MAX_IO)]
		Int32 dwIOPortLength[];
		Int32 dwNumIRQs;
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axppi02w::MAX_IRQ)]
		Int32 dwIRQRegisters[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axppi02w::MAX_IRQ)]
		Int32 dwIRQAttrib[];
		Int32 dwNumDMAs;
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axppi02w::MAX_DMA)]
		Int32 dwDMALst[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axppi02w::MAX_DMA)]
		Int32 dwDMAAttrib[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axppi02w::MAX_RSV)]
		Int32 dwReserved1[];
	};

	// API
	[DllImport("axppi02.dll")]
	static bool Pi02GetVersion(int* pdwDllVer, int* pdwDrvVer);
	[DllImport("axppi02.dll")]
	static bool Pi02Create(short* pwLogSocket, int hWnd, short uWMBase, int* pvInitArg);
	[DllImport("axppi02.dll")]
	static bool Pi02Close(short wLogSocket);
	[DllImport("axppi02.dll")]
	static bool Pi02GetResource(short wLogSocket, [In][Out] Resource* pRes);
	[DllImport("axppi02.dll")]
	static bool Pi02InPort(short wLogSocket, int dwPort, Byte* pbValue);
	[DllImport("axppi02.dll")]
	static bool Pi02OutPort(short wLogSocket, int dwPort, Byte bValue);
	[DllImport("axppi02.dll")]
	static bool Pi02SetDirection(short wLogSocket, Byte bDirectionBit);
	[DllImport("axppi02.dll")]
	static int  Pi02GetLastError(short wLogSocket);



	/*****************************************************************************
	 * @\  AXP-PI02DLL,Driver̃o[Wԍ擾
	 * 	 pdwDllVer --- DLLo[Wԍi[AhX
	 *		 pdwDrvVer --- Drivero[Wԍi[AhX
	 * ߒl	 true	   --- 
	 *		 false	   --- s
	 *****************************************************************************/
	static bool GetVersion ( int* pdwDllVer, int* pdwDrvVer )
	{
		try {
			return Pi02GetVersion(pdwDllVer, pdwDrvVer);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-PI02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	/*****************************************************************************
	 * @\  AXP-PI02̔Cӂ̃foCX̎gp錾
	 * 	 pwLogSocket	--- gpfoCXi[AhX
	 *       hWnd       --- bZ[W󂯂EChEnh
	 *       uWMBase    --- bZ[Whc̃x[X
	 *       pvInitArg  --- \
	 * ߒl	 true		--- 
	 *		 false		--- s
	 *****************************************************************************/
	static bool Create ( short* pwLogSocket, int hWnd, short uWMBase, int* pvInitArg )
	{
		try {
			return Pi02Create(pwLogSocket, hWnd, uWMBase, pvInitArg); //
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-PI02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	/*****************************************************************************
	 * @\  AXP-PI02̔Cӂ̃foCX̎gpJ
	 * 	 wLogSocket  --- gpfoCX
	 * ߒl	 true	   --- 
	 *		 false	   --- s
	 *****************************************************************************/
	static bool Close ( short wLogSocket )
	{
		try {
			return Pi02Close(wLogSocket);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-PI02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	/*****************************************************************************
	 * @\  wfoCX̃\[X擾
	 * 	 wLogSocket --- ׂfoCX
	 *		 pResInfo --- \[Xi[\̂̃AhX
	 * ߒl	 true	  --- 
	 *		 false	  --- s
	 *****************************************************************************/
	static bool GetResource ( short wLogSocket, [In][Out] Resource* pResInfo )
	{
		try {
			return Pi02GetResource(wLogSocket, pResInfo);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-PI02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	/*****************************************************************************
	 * @\  |[g``bɑ΂PoCg͂s܂
	 * 	 wLogSocket --- ΏۃfoCX
	 *		 dwPort   --- Ώۃ|[gԍ
	 *       pbValue  --- ͒li[̈ւ̃|C^
	 * ߒl	 true	  --- 
	 *		 false	  --- s
	 *****************************************************************************/
	static bool InPort( short wLogSocket, int dwPort, Byte* pbValue )
	{
		try {
			return Pi02InPort( wLogSocket, dwPort, pbValue );
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-PI02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	/*****************************************************************************
	 * @\  |[g``bA܂̓R}h|[gւPoCgo
	 * 	 wLogSocket --- ΏۃfoCX
	 *		 dwPort   --- Ώۃ|[gԍ
	 *       bValue   --- o͂l
	 * ߒl	 true	  --- 
	 *		 false	  --- s
	 *****************************************************************************/
	static bool OutPort( short wLogSocket, int dwPort, Byte bValue )
	{
		try {
			return Pi02OutPort(wLogSocket, dwPort, bValue);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-PI02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	/*****************************************************************************
	 * @\  fBNV|[gɏo
	 * 	 wLogSocket --- ΏۃfoCX
	 *       bDirectionBit --- fBNV|[gɏޒl
	 * ߒl	 true	  --- 
	 *		 false	  --- s
	 *****************************************************************************/
	static bool SetDirection( short wLogSocket, Byte bDirectionBit )
	{
		try {
			return Pi02SetDirection(wLogSocket, bDirectionBit);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-PI02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	/*****************************************************************************
	 * @\  G[R[h擾
	 * 	 wLogSocket --- ΏۃfoCX
	 * ߒl	 G[R[h
	 *****************************************************************************/
	static int GetLastError( short wLogSocket )
	{
		try {
			if (mErrWradll == ERR_WRAPDLL) {	// bp[֐G[Ȃ
				mErrWradll = SUCCESS;			// NA
				return ERR_WRAPDLL;
			} else {
				return Pi02GetLastError(wLogSocket);
			}
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-PI02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = SUCCESS;	// bp[֐G[
			return ERR_WRAPDLL;
		}
	}

};
