/*****************************************************************************
 *	axppi02s.cs
 *
 *	AXP-PI02
 *
 *	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
 *
 *	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
 *
 *****************************************************************************/

//=========================================================================
// rh IvV̐ݒ菇܂B
//
// 1.vWFNg [vpeB y[W] _CAO {bNXJ܂B
// 2.[\vpeB] tH_NbN܂B 
// 3.[rh] vpeB y[WNbN܂B 
// 4.[Z[t [hȊÕR[h ubN̋] vpeBuTRUEvɕύX܂B
//=========================================================================
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SamplePi02
{
    public partial class Axppi02s : Form
    {
		static Axppi02w Pi02w;

        public Axppi02s()
        {
            InitializeComponent();
        }

        private unsafe void Axppi02s_Load(object sender, EventArgs e)
        {
			String szbuf;
			int dwDllVer, dwDrvVer;
			bool bResult;				// 
			short wLogSocket;			// foCXi[
			Byte  Value;
			Axppi02w.Resource ri;		// \[X
			int vInitArg;
			int i;

			Pi02w = new Axppi02w();
			ri    = new Axppi02w.Resource();
			ri.dwMemBase		= new int[Axppi02w.MAX_MEM];
			ri.dwMemLength		= new int[Axppi02w.MAX_MEM];
			ri.dwMemAttrib		= new int[Axppi02w.MAX_MEM];
			ri.dwIOPortBase		= new int[Axppi02w.MAX_IO];
			ri.dwIOPortLength	= new int[Axppi02w.MAX_IO];
			ri.dwIRQRegisters	= new int[Axppi02w.MAX_IRQ];
			ri.dwIRQAttrib		= new int[Axppi02w.MAX_IRQ];
			ri.dwDMALst			= new int[Axppi02w.MAX_DMA];
			ri.dwDMAAttrib		= new int[Axppi02w.MAX_DMA];
			ri.dwReserved1		= new int[Axppi02w.MAX_RSV];

			// 
			ri.dwNumMemWindows = 0;
			for (i=0; i<Axppi02w.MAX_MEM; i++) {
				ri.dwMemBase[i]   = 0;
				ri.dwMemLength[i] = 0;
				ri.dwMemAttrib[i] = 0;
			}
			ri.dwNumIOPorts = 0;
			for (i=0; i<Axppi02w.MAX_IO; i++) {
				ri.dwIOPortBase[i]   = 0;
				ri.dwIOPortLength[i] = 0;
			}
			ri.dwNumIRQs = 0;
			for (i=0; i<Axppi02w.MAX_IRQ; i++) {
				ri.dwIRQRegisters[i] = 0;
				ri.dwIRQAttrib[i]    = 0;
			}
			ri.dwNumDMAs = 0;
			for (i=0; i<Axppi02w.MAX_DMA; i++) {
				ri.dwDMALst[i]    = 0;
				ri.dwDMAAttrib[i] = 0;
			}
			for (i=0; i<Axppi02w.MAX_RSV; i++)
				ri.dwReserved1[i] = 0;

			//--------------------	o[Wԍ\	----------------------------------
			// AXP-PI02 DLL,Driver̃o[Wԍ擾
			if (Pi02w.GetVersion(&dwDllVer, &dwDrvVer) == false) {
				ErrorMessage(Axppi02w.SOCKET_AUTO);
				return;
			}
			szbuf = String.Concat("Version\n",
									String.Format("DLL: {0:x8}H\n", dwDllVer),
									String.Format("DRV: {0:x8}H",   dwDrvVer));
			ResultMessage(szbuf);

			//-----------------------  AXP-PI02̎gp錾	 -----------------------------
			vInitArg = 0;
			wLogSocket = Axppi02w.SOCKET_AUTO;			// gp̃foCXT܂B
			bResult = Pi02w.Create( &wLogSocket, 0, 0, &vInitArg );
			if (bResult == false) {
				ErrorMessage(Axppi02w.SOCKET_AUTO);
				return;
			}
			szbuf = String.Concat("Created\n\n",
									String.Format("LogSocket: {0}", wLogSocket));
			ResultMessage(szbuf);

			//-------------------------  \[X擾  -----------------------------
			if (Pi02w.GetResource(wLogSocket, ref ri) == false) {
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String.Concat(String.Format("IO Address: {0:x4}H - {1:x4}H\n",
													ri.dwIOPortBase[0],
													ri.dwIOPortBase[0] + ri.dwIOPortLength[0] - 1));
			ResultMessage(szbuf);

			//---------------------------  샂[h̐ݒ  -----------------------------
			// fBNV 15H 
			if (Pi02w.SetDirection(wLogSocket, 0x15) == false) {
				ErrorMessage(wLogSocket);
				return;
			}
			// R}h|[g 90H 
			if (Pi02w.OutPort(wLogSocket, Axppi02w.PORT_CMD, 0x90) == false) {
				ErrorMessage(wLogSocket);
				return;
			}
			// fBNV 39H 
			if (Pi02w.SetDirection(wLogSocket, 0x39) == false) {
				ErrorMessage(wLogSocket);
				return;
			}
			// fBNV 28H 
			if (Pi02w.SetDirection(wLogSocket, 0x28) == false) {
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String.Concat("샂[hݒ肵܂\n",
									"|[g`@\n",
									"|[ga@o\n",
									"|[gb@o\n");
			ResultMessage(szbuf);

			//---------------------------  o͎s  -----------------------------
			Value = 0x55;
			if (Pi02w.OutPort(wLogSocket, Axppi02w.PORT_B, Value) == false) 
			{
				ErrorMessage(wLogSocket);
				return;
			}
			ResultMessage(String.Format("|[ga {0:x2}H o͂܂", Value));

			//---------------------------  ͎s  -----------------------------
			Value = 0x00;
			if (Pi02w.InPort(wLogSocket, Axppi02w.PORT_A, &Value) == false) {
				ErrorMessage(wLogSocket);
				return;
			}
			ResultMessage(String.Format("͒l |[g`: {0:x2}H", Value));

			//-------------------  AXP-PI02̎gpJ	 -------------------------------
			if (Pi02w.Close(wLogSocket) == false) {
				ErrorMessage(wLogSocket);
				return;
			}
			ResultMessage("Closed");
            this.Close();
        }

		/*============================================================================
		// ʂ\
		//===========================================================================*/
		private void ResultMessage(string buf)
		{
			MessageBox.Show(buf, this.Text, 
							MessageBoxButtons.OK, MessageBoxIcon.Information);
		}

		/*============================================================================
		// װүނ\
		//===========================================================================*/
		private void ErrorMessage(short wLogSocket)
		{
			int dwRes = Pi02w.GetLastError(wLogSocket);
			string buf;

			switch (dwRes)
			{
				case Axppi02w.ERR_WRAPDLL:
				case Axppi02w.ERR_SYSTEM:
					dwRes = System.Runtime.InteropServices.Marshal.GetLastWin32Error();
					buf = String.Concat("System error\n\n", 
										String.Format("Error code: {0:x8}H", dwRes));
					break;

				default:
					buf = String.Concat("AXP-PI02 error\n\n",
										String.Format("Error code: {0:x8}H", dwRes));
					break;
			}
			MessageBox.Show(buf, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Stop);
		}

    }
}