/*============================================================================
//	Axppi02w.cs
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//==========================================================================*/
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.InteropServices;

namespace SamplePi02
{
	/// <summary>
	/// Axppi02w ̊Tv̐łB
	/// </summary>
	public class Axppi02w
	{
		private int mErrWradll = SUCCESS;	// bp[֐G[

		public const int	MAX_SOCKETS				= 16;
		public const short	SOCKET_AUTO				= -1;

		public const int	PORT_A					= 0x0;	// |[g`
		public const int	PORT_B					= 0x1;	// |[ga
		public const int	PORT_C					= 0x2;	// |[gb
		public const int	PORT_CMD				= 0x3;	// R}h|[g

		// G[R[h
		public const int	SUCCESS					= 0;	// ُȂiIj
		public const int	ERR_SYSTEM				= 1;	// Windows  GetLastError() R[Ă
															// ɃhCo[hĂȂ\܂
		public const int	ERR_NO_DEVICE			= 2;	// gp\ȃfoCX܂
		public const int	ERR_IN_USE				= 3;	// w̃foCX͎gpł
		public const int	ERR_INVALID_SOCKET		= 4;	// Ș_\Pbgł
		public const int	ERR_RESOURCE			= 5;	// \[XG[
		public const int	ERR_INVALID_PORT		= 6;	// sȃ|[gv
		public const int	ERR_INVALID_ARGUMENT	= 7;	// sȈv܂
		public const int	ERR_WRAPDLL				= -1;	// bp[֐G[

		// AvP[Vɑ郁bZ[W
		public const int	WM_OFS_CARD_REMOVAL		= 0;	// J[hꂽ
		public const int	WM_OFS_IN				= 1;	// O͔iIvVj

		// \[X\
		public const int	MAX_MEM					= 9;
		public const int	MAX_IO					= 20;
		public const int	MAX_IRQ					= 7;
		public const int	MAX_DMA					= 7;
		public const int	MAX_RSV					= 3;

		[StructLayout(LayoutKind.Sequential)]
		public struct Resource
		{
			public int		dwNumMemWindows;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_MEM)]
			public int[]	dwMemBase;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_MEM)]
			public int[]	dwMemLength;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_MEM)]
			public int[]	dwMemAttrib;
			public int		dwNumIOPorts;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IO)]
			public int[]	dwIOPortBase;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IO)]
			public int[]	dwIOPortLength;
			public int		dwNumIRQs;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IRQ)]
			public int[]	dwIRQRegisters;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IRQ)]
			public int[]	dwIRQAttrib;
			public int		dwNumDMAs;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_DMA)]
			public int[]	dwDMALst;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_DMA)]
			public int[]	dwDMAAttrib;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_RSV)]
			public int[]	dwReserved1;
		}

		// API
		[DllImport("axppi02.dll")]
		public extern static unsafe bool Pi02GetVersion(int* pdwDllVer, int* pdwDrvVer);
		[DllImport("axppi02.dll")]
		public extern static unsafe bool Pi02Create(short* pwLogSocket, int hWnd, short uWMBase, int* pvInitArg);
		[DllImport("axppi02.dll")]
		public extern static        bool Pi02Close(short wLogSocket);
		[DllImport("axppi02.dll")]
		public extern static        bool Pi02GetResource(short wLogSocket, ref Resource pRes);
		[DllImport("axppi02.dll")]
		public extern static unsafe bool Pi02InPort(short wLogSocket, int dwPort, Byte* pbValue);
		[DllImport("axppi02.dll")]
		public extern static        bool Pi02OutPort(short wLogSocket, int dwPort, Byte bValue);
		[DllImport("axppi02.dll")]
		public extern static        bool Pi02SetDirection(short wLogSocket, Byte bDirectionBit);
		[DllImport("axppi02.dll")]
		public extern static        int  Pi02GetLastError(short wLogSocket);

		public Axppi02w()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
		}

		/*****************************************************************************
		 * @\  AXP-PI02DLL,Driver̃o[Wԍ擾
		 * 	 pdwDllVer --- DLLo[Wԍi[AhX
		 *		 pdwDrvVer --- Drivero[Wԍi[AhX
		 * ߒl	 true	   --- 
		 *		 false	   --- s
		 *****************************************************************************/
		public unsafe bool GetVersion ( int* pdwDllVer, int* pdwDrvVer )
		{
			try {
				return Pi02GetVersion(pdwDllVer, pdwDrvVer);
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-PI02 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}

		/*****************************************************************************
		 * @\  AXP-PI02̔Cӂ̃foCX̎gp錾
		 * 	 pwLogSocket	--- gpfoCXi[AhX
		 *       hWnd       --- bZ[W󂯂EChEnh
		 *       uWMBase    --- bZ[Whc̃x[X
		 *       pvInitArg  --- \
		 * ߒl	 true		--- 
		 *		 false		--- s
		 *****************************************************************************/
		public unsafe bool Create ( short* pwLogSocket, int hWnd, short uWMBase, int* pvInitArg )
		{
			try {
				return Pi02Create(pwLogSocket, hWnd, uWMBase, pvInitArg); //
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-PI02 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}

		/*****************************************************************************
		 * @\  AXP-PI02̔Cӂ̃foCX̎gpJ
		 * 	 wLogSocket  --- gpfoCX
		 * ߒl	 true	   --- 
		 *		 false	   --- s
		 *****************************************************************************/
		public bool Close ( short wLogSocket )
		{
			try {
				return Pi02Close(wLogSocket);
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-PI02 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}

		/*****************************************************************************
		 * @\  wfoCX̃\[X擾
		 * 	 wLogSocket --- ׂfoCX
		 *		 pResInfo --- \[Xi[\̂̃AhX
		 * ߒl	 true	  --- 
		 *		 false	  --- s
		 *****************************************************************************/
		public bool GetResource ( short wLogSocket, ref Resource pResInfo )
		{
			try {
				return Pi02GetResource(wLogSocket, ref pResInfo);
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-PI02 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}

		/*****************************************************************************
		 * @\  |[g``bɑ΂PoCg͂s܂
		 * 	 wLogSocket --- ΏۃfoCX
		 *		 dwPort   --- Ώۃ|[gԍ
		 *       pbValue  --- ͒li[̈ւ̃|C^
		 * ߒl	 true	  --- 
		 *		 false	  --- s
		 *****************************************************************************/
		public unsafe bool InPort( short wLogSocket, int dwPort, Byte* pbValue )
		{
			try {
				return Pi02InPort( wLogSocket, dwPort, pbValue );
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-PI02 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}

		/*****************************************************************************
		 * @\  |[g``bA܂̓R}h|[gւPoCgo
	 	* 	 wLogSocket --- ΏۃfoCX
	 	*		 dwPort   --- Ώۃ|[gԍ
	 	*       bValue   --- o͂l
		 * ߒl	 true	  --- 
	 	*		 false	  --- s
	 	*****************************************************************************/
		public bool OutPort( short wLogSocket, int dwPort, Byte bValue )
		{
			try {
				return Pi02OutPort(wLogSocket, dwPort, bValue);
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-PI02 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}

		/*****************************************************************************
		 * @\  fBNV|[gɏo
		 * 	 wLogSocket --- ΏۃfoCX
		 *       bDirectionBit --- fBNV|[gɏޒl
		 * ߒl	 true	  --- 
		 *		 false	  --- s
		 *****************************************************************************/
		public bool SetDirection( short wLogSocket, Byte bDirectionBit )
		{
			try {
				return Pi02SetDirection(wLogSocket, bDirectionBit);
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-PI02 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}

		/*****************************************************************************
		 * @\  G[R[h擾
		 * 	 wLogSocket --- ΏۃfoCX
		 * ߒl	 G[R[h
		 *****************************************************************************/
		public int GetLastError( short wLogSocket )
		{
			try {
				if (mErrWradll == ERR_WRAPDLL) {	// bp[֐G[Ȃ
					mErrWradll = SUCCESS;			// NA
					return ERR_WRAPDLL;
				} else {
					return Pi02GetLastError(wLogSocket);
				}
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-PI02 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = SUCCESS;	// bp[֐G[
				return ERR_WRAPDLL;
			}
		}
	}
};
