'*****************************************************************************
'* axppi02s.vb                                                               *
'*                                                                           *
'* AXP-PI02Tv\[X                                                    *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'* ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B                    *
'*                                                                           *
'*****************************************************************************

Option Strict Off
Option Explicit On 

Imports System.Runtime.InteropServices

Public Class Axppi02s

    Dim Pi02w As Axppi02w

    Private Sub Axppi02s_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim strbuf As String
        Dim dwDllVer As Long
        Dim dwDrvVer As Long
        Dim wLogSocket As Integer
        Dim ri As Axppi02w.Resource
        Dim Value As Byte
        Dim i As Integer

        ' 
        Pi02w = New Axppi02w
        ri = New Axppi02w.Resource
        ri.dwMemBase = New Integer(Axppi02w.MAX_MEM) {}
        ri.dwMemLength = New Integer(Axppi02w.MAX_MEM) {}
        ri.dwMemAttrib = New Integer(Axppi02w.MAX_MEM) {}
        ri.dwIOPortBase = New Integer(Axppi02w.MAX_IO) {}
        ri.dwIOPortLength = New Integer(Axppi02w.MAX_IO) {}
        ri.dwIRQRegisters = New Integer(Axppi02w.MAX_IRQ) {}
        ri.dwIRQAttrib = New Integer(Axppi02w.MAX_IRQ) {}
        ri.dwDMALst = New Integer(Axppi02w.MAX_DMA) {}
        ri.dwDMAAttrib = New Integer(Axppi02w.MAX_DMA) {}
        ri.dwReserved1 = New Integer(Axppi02w.MAX_RSV) {}

        ' 
        ri.dwNumMemWindows = 0
        For i = 0 To Axppi02w.MAX_MEM
            ri.dwMemBase(i) = 0
            ri.dwMemLength(i) = 0
            ri.dwMemAttrib(i) = 0
        Next
        ri.dwNumIOPorts = 0
        For i = 0 To Axppi02w.MAX_IO
            ri.dwIOPortBase(i) = 0
            ri.dwIOPortLength(i) = 0
        Next
        ri.dwNumIRQs = 0
        For i = 0 To Axppi02w.MAX_IRQ
            ri.dwIRQRegisters(i) = 0
            ri.dwIRQAttrib(i) = 0
        Next
        ri.dwNumDMAs = 0
        For i = 0 To Axppi02w.MAX_DMA
            ri.dwDMALst(i) = 0
            ri.dwDMAAttrib(i) = 0
        Next
        For i = 0 To Axppi02w.MAX_RSV
            ri.dwReserved1(i) = 0
        Next

        '=========================================================================
        ' o[W̎擾
        '=========================================================================
        If Pi02w.GetVersion(dwDllVer, dwDrvVer) = False Then
            ErrorMessage(Axppi02w.SOCKET_AUTO)
            Exit Sub
        End If
        strbuf = String.Concat("GetVersion", vbCrLf, _
                                String.Format("DLL Version: {0:X8}H", dwDllVer), vbCrLf, _
                                String.Format("DRV Version: {0:X8}H", dwDrvVer))
        ResultMessage(strbuf)

        '=========================================================================
        ' AXP-PI02 ̎gp錾
        '=========================================================================
        wLogSocket = Axppi02w.SOCKET_AUTO   ' gp̃foCX
        If Pi02w.Create(wLogSocket, 0, 0, 0) = False Then
            ErrorMessage(Axppi02w.SOCKET_AUTO)
            Exit Sub
        End If
        strbuf = String.Concat("Created", vbCrLf, vbCrLf, _
                                String.Format("LogSocket: {0:d}", wLogSocket))
        ResultMessage(strbuf)

        '=========================================================================
        ' \[X擾
        '=========================================================================
        If Pi02w.GetResource(wLogSocket, ri) = False Then
            ErrorMessage(wLogSocket)
            Exit Sub
        End If
        strbuf = String.Concat(String.Format("IO Address: {0:X4}H - {1:X4}H", _
                                                ri.dwIOPortBase(0), _
                                                ri.dwIOPortBase(0) + ri.dwIOPortLength(0) - 1))
        ResultMessage(strbuf)

        '=========================================================================
        ' 샂[h̐ݒ
        '=========================================================================
        ' fBNV 15h 
        If Pi02w.SetDirection(wLogSocket, &H15) = False Then
            ErrorMessage(wLogSocket)
            Exit Sub
        End If
        ' R}h|[g 90h 
        If Pi02w.OutPort(wLogSocket, Axppi02w.PORT_CMD, &H90) = False Then
            ErrorMessage(wLogSocket)
            Exit Sub
        End If
        ' fBNV 39h 
        If Pi02w.SetDirection(wLogSocket, &H39) = False Then
            ErrorMessage(wLogSocket)
            Exit Sub
        End If
        ' fBNV 28h 
        If Pi02w.SetDirection(wLogSocket, &H28) = False Then
            ErrorMessage(wLogSocket)
            Exit Sub
        End If

        strbuf = String.Concat("샂[h:", vbCrLf, _
                                "|[g`@@", vbCrLf, _
                                "|[ga@@o", vbCrLf, _
                                "|[gb@@o")
        ResultMessage(strbuf)

        '=========================================================================
        ' o͎s
        '=========================================================================
        Value = &H55
        If Pi02w.OutPort(wLogSocket, Axppi02w.PORT_B, Value) = False Then
            ErrorMessage(wLogSocket)
            Exit Sub
        End If

        strbuf = String.Concat("OunPort", vbCrLf, _
                                String.Format("Port B  {0:x2} o͂܂", Value))
        ResultMessage(strbuf)

        '=========================================================================
        ' ͎s
        '=========================================================================
        If Pi02w.InPort(wLogSocket, Axppi02w.PORT_A, Value) = False Then
            ErrorMessage(wLogSocket)
            Exit Sub
        End If

        strbuf = String.Concat("InPort", vbCrLf, _
                                String.Format("Port A: {0:x2}H", Value))
        ResultMessage(strbuf)

        '=========================================================================
        ' AXP-PI02 J
        '=========================================================================
        If Pi02w.Close(wLogSocket) = False Then
            ErrorMessage(wLogSocket)
            Exit Sub
        End If
        ResultMessage("Closed")
        Me.Close()
    End Sub

    '============================================================================
    '    ʂ\
    '============================================================================
    Private Sub ResultMessage(ByVal lpszbuf As String)
        MsgBox(lpszbuf, MsgBoxStyle.OKOnly + MsgBoxStyle.Information, Me.Text)
    End Sub

    '============================================================================
    '    G[bZ[W\
    '============================================================================
    Private Sub ErrorMessage(ByVal wLogSocket As Short)
        Dim dwRes As Integer
        Dim szBuf As String

        dwRes = Pi02w.GetLastError(wLogSocket)
        Select Case dwRes
            Case Axppi02w.ERR_WRAPDLL, Axppi02w.ERR_SYSTEM
                dwRes = System.Runtime.InteropServices.Marshal.GetLastWin32Error()
                szBuf = String.Concat("System error", vbCrLf, vbCrLf, _
                                        String.Format("Error code: {0:X8}H", dwRes))
            Case Else
                szBuf = String.Concat("AXP-PI02 error", vbCrLf, vbCrLf, _
                                        String.Format("Error code: {0:X8}H", dwRes))
        End Select
        MsgBox(szBuf, MsgBoxStyle.OKOnly + MsgBoxStyle.Critical, Me.Text)
    End Sub

End Class
