/*****************************************************************************
 *	Axppi02w.c
 *
 *	AXP-PI02
 *
 *	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
 *
 *	Date 1998/10
 *
 *****************************************************************************/
#include <windows.h>
#include <tchar.h>
#include "axppi02w.h"	// AXP-PI02

//---------- X^eBbN֐ & X^eBbNϐ(萔)	----------------------
static BOOL Pi02wGetDllExportFunc();
static HMODULE hDLL = NULL;

// DLL GNX|[g֐AhX̊i[pϐ
static FARPROC pPi02GetVersion;
static FARPROC pPi02Create;
static FARPROC pPi02Close;
static FARPROC pPi02GetResource;
static FARPROC pPi02InPort;
static FARPROC pPi02OutPort;
static FARPROC pPi02SetDirection;
static FARPROC pPi02GetLastError;

BOOL Pi02wDllOpen ( void )
/*****************************************************************************
 * @\  axppi02.dll[h
 * 	 Ȃ
 * ߒl	 TRUE  --- 
 *		 FALSE --- s
 *****************************************************************************/
{
	if (hDLL != NULL) {
		return FALSE;
	}
	hDLL = (HMODULE)LoadLibrary(AXPPI02_DLL_NAME);
	if (hDLL == NULL) {
		return FALSE;
	}
	if (Pi02wGetDllExportFunc() == FALSE) {
		// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Pi02wDllClose();
		return FALSE;
	}
	return TRUE;
}

BOOL Pi02wDllClose ( void )
/*****************************************************************************
 * @\  axppi02.dllA[h
 * 	 Ȃ
 * ߒl	 TRUE  --- 
 *		 FALSE --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	if (FreeLibrary(hDLL) == TRUE) {
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}

BOOL Pi02wGetVersion ( PDWORD pdwDllVer, PDWORD pdwDrvVer )
/*****************************************************************************
 * @\  AXP-PI02DLL,Driver̃o[Wԍ擾
 * 	 pdwDllVer --- DLLo[Wԍi[AhX
 *		 pdwDrvVer --- Drivero[Wԍi[AhX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pPi02GetVersion)(pdwDllVer, pdwDrvVer);
}

BOOL Pi02wCreate ( PWORD pwLogSocket, HWND hWnd, UINT uWMBase, PVOID pvInitArg )
/*****************************************************************************
 * @\  AXP-PI02̔Cӂ̃foCX̎gp錾
 * 	 pwLogSocket	--- gpfoCXi[AhX
 *       hWnd       --- bZ[W󂯂EChEnh
 *       uWMBase    --- bZ[Whc̃x[X
 *       pvInitArg  --- \
 * ߒl	 TRUE		--- 
 *		 FALSE		--- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pPi02Create)(pwLogSocket, hWnd, uWMBase, pvInitArg); //
}            

BOOL Pi02wClose ( WORD wLogSocket )
/*****************************************************************************
 * @\  AXP-PI02̔Cӂ̃foCX̎gpJ
 * 	 wLogSocket  --- gpfoCX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pPi02Close)(wLogSocket);
}

BOOL Pi02wGetResource ( WORD wLogSocket, PPI02_R pResInfo )
/*****************************************************************************
 * @\  wfoCX̃\[X擾
 * 	 wLogSocket --- ׂfoCX
 *		 pResInfo --- \[Xi[\̂̃AhX
 * ߒl	 TRUE	  --- 
 *		 FALSE	  --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pPi02GetResource)(wLogSocket, pResInfo);
}

BOOL Pi02wInPort( WORD wLogSocket, DWORD dwPort, PBYTE pbValue )
/*****************************************************************************
 * @\  |[g``bɑ΂PoCg͂s܂
 * 	 wLogSocket --- ΏۃfoCX
 *		 dwPort   --- Ώۃ|[gԍ
 *       pbValue  --- ͒li[̈ւ̃|C^
 * ߒl	 TRUE	  --- 
 *		 FALSE	  --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pPi02InPort)( wLogSocket, dwPort, pbValue );
}

BOOL Pi02wOutPort( WORD wLogSocket, DWORD dwPort, BYTE bValue )
/*****************************************************************************
 * @\  |[g``bA܂̓R}h|[gւPoCgo
 * 	 wLogSocket --- ΏۃfoCX
 *		 dwPort   --- Ώۃ|[gԍ
 *       bValue   --- o͂l
 * ߒl	 TRUE	  --- 
 *		 FALSE	  --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pPi02OutPort)(wLogSocket, dwPort, bValue);
}

BOOL Pi02wSetDirection( WORD wLogSocket, BYTE bDirectionBit )
/*****************************************************************************
 * @\  fBNV|[gɏo
 * 	 wLogSocket --- ΏۃfoCX
 *       bDirectionBit --- fBNV|[gɏޒl
 * ߒl	 TRUE	  --- 
 *		 FALSE	  --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pPi02SetDirection)(wLogSocket, bDirectionBit);
}

DWORD Pi02wGetLastError( WORD wLogSocket )
/*****************************************************************************
 * @\  G[R[h擾
 * 	 wLogSocket --- ΏۃfoCX
 * ߒl	 G[R[h
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pPi02GetLastError)(wLogSocket);
}

static BOOL Pi02wGetDllExportFunc ( void )
/*---------------------------------------------------------------------------
 * 	 DLLGNX|[g֐AhX̎擾
 * 	 Ȃ
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *---------------------------------------------------------------------------*/
{
	// Pi02GetVersion ̃AhX擾
	pPi02GetVersion = GetProcAddress(hDLL, _T("Pi02GetVersion"));
	if (pPi02GetVersion == NULL) {
		return FALSE;
	}

	// Pi02Create ̃AhX擾
	pPi02Create = GetProcAddress(hDLL, _T("Pi02Create"));
	if (pPi02Create == NULL) {
		return FALSE;
	}

	// Pi02Close ̃AhX擾
	pPi02Close = GetProcAddress(hDLL, _T("Pi02Close"));
	if (pPi02Close == NULL) {
		return FALSE;
	}

	// Pi02GetResource ̃AhX擾         Pi02GetResource
	pPi02GetResource = GetProcAddress(hDLL, _T("Pi02GetResource"));
	if ( pPi02GetResource == NULL ) {
		return FALSE;
	}

	// Pi02InPort ̃AhX擾
	pPi02InPort = GetProcAddress(hDLL, _T("Pi02InPort"));
	if ( pPi02InPort == NULL ) {
		return FALSE;
	}

	// Pi02OutPort ̃AhX擾
	pPi02OutPort = GetProcAddress(hDLL, _T("Pi02OutPort"));
	if ( pPi02OutPort == NULL ) {
		return FALSE;
	}

	// Pi02SetDirection ̃AhX擾
	pPi02SetDirection = GetProcAddress(hDLL, _T("Pi02SetDirection"));
	if ( pPi02SetDirection == NULL ) {
		return FALSE;
	}

	// Pi02GetLastError ̃AhX擾
	pPi02GetLastError = GetProcAddress(hDLL, _T("Pi02GetLastError"));
	if ( pPi02GetLastError == NULL ) {
		return FALSE;
	}

	return TRUE;	// SĂ DLL GNX|[g֐AhX擾
}
